/***********************************************************************************************************************
 *
 * OpenBlueSky - NetBeans Platform Enhancements
 * Copyright (C) 2006-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://openbluesky.kenai.com
 * SCM: https://kenai.com/hg/openbluesky~src
 *
 **********************************************************************************************************************/
package it.tidalwave.netbeans.examples.nodes.example8.view;

import javax.annotation.Nonnull;
import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.Action;
import it.tidalwave.util.Finder.SortDirection;
import static it.tidalwave.role.Sortable.Sortable;
import static it.tidalwave.netbeans.util.EnhancedLookups.*;

/***********************************************************************************************************************
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class SortDirectionAction extends AbstractAction
  {
    @Nonnull
    private final Object object;
    
    @Nonnull
    private final SortDirection sortDirection;

    public SortDirectionAction (final @Nonnull Object object, 
                                final @Nonnull String name,
                                final @Nonnull SortDirection sortDirection) 
      {
        this.object = object;
        this.sortDirection = sortDirection;
        super.putValue(Action.NAME, name);
      }

    @Override
    public void actionPerformed (final @Nonnull ActionEvent event)
      {
        lookup(object, Sortable).setSortDirection(sortDirection);
      }    
  }
